#version 300 es
uniform mediump float threshold;
uniform mediump float lowThreshold;
uniform mediump float brightness;
uniform lowp vec3 tint;
in mediump vec2 vTex;
uniform lowp sampler2D samplerFront;
uniform mediump vec2 srcStart;
uniform mediump vec2 srcEnd;
uniform mediump vec2 destStart;
uniform mediump vec2 destEnd;
uniform lowp sampler2D samplerBack;
out lowp vec4 outColor;
precision mediump float;
mediump float weight = 0.;


mediump float luminance(vec3 rgb)
{
    const mediump vec3 W = vec3(0.2125, 0.7154, 0.0721);
    return dot(rgb, W);
}

void main(void)
{
    lowp vec4 front = texture(samplerFront, vTex);
    mediump vec2 n = (vTex - srcStart) / (srcEnd - srcStart);
    lowp vec4 back = texture(samplerBack, mix(destStart, destEnd, n));
    
    outColor =  (smoothstep(lowThreshold , threshold , luminance(back.rgb)) * back *brightness * front.a + vec4(0.,0.,0.,front.a)) * vec4(tint, 1.);
}